<%
   option explicit
   on error resume next
%>

<!-- #include file="include/header_footer.asi" -->
<!-- #include file="include/common.asi" -->
<!-- #include file="include/interface.asi" -->
<!-- #include file="include/preference.asi" -->
<!-- #include file="include/core.asi" -->

<%
' -----------------------------------------------------------------------------
' Rules:
' saveasformat
' saveportfolio
' saveasportfolio

const SCNT_DEFAULT_PAGE_COUNT          = 9

const SCNT_WHT_NONE                    = 0
const SCNT_WHT_TOP                     = 1
const SCNT_WHT_BOTTOM                  = 2

' -----------------------------------------------------------------------------
class scr_ScreeningResults
   ' -----------------------------------------------------------------------------
   private sub Class_Initialize()
      on error resume next
      dim objScreenList, objFormatList, objPortfolioList, objCategoryList, objDatasetList
      dim objRequestor, objScreen, objFormat, objPortfolio
      dim objResultForSave, objPortfolioForSave, objForRead
      dim czFormatEditor, czCode, czDesc, czShortDesc

      m_bResultCreated = false

      m_bFound = false
      m_czEndScript = "EraseSearch();"

      m_iColumns = 0
      m_iTableColumns = 0
      m_iTableColumnsEditor = 0
      m_iTickerColumn = -1
      m_iNameColumn = -1

      m_iStartIndex = 0
      m_iIndex = 0

      set objRequestor = new scr_MultipleRequestor
      if not objRequestor.Create("[scr_ScreeningResults::Class_Initialize]") then exit sub

      set objScreenList = new scr_ScreenList
      if not objScreenList.PrepareRequest("[scr_ScreeningResults::Class_Initialize]") then exit sub
      if not objRequestor.Add(objScreenList, "[scr_ScreeningResults::Class_Initialize]") then exit sub

      set objPortfolioList = new scr_PortfolioList
      if not objPortfolioList.PrepareRequest("[scr_ScreeningResults::Class_Initialize]") then exit sub
      if not objRequestor.Add(objPortfolioList, "[scr_ScreeningResults::Class_Initialize]") then exit sub

      set objFormatList = new scr_FormatList
      if not objFormatList.PrepareRequest("[scr_ScreeningResults::Class_Initialize]") then exit sub
      if not objRequestor.Add(objFormatList, "[scr_ScreeningResults::Class_Initialize]") then exit sub

      set objDatasetList = new scr_DatasetList
      if not objDatasetList.PrepareRequest("[scr_CriteriaBuilder::Class_Initialize]") then exit sub
      if not objRequestor.Add(objDatasetList, "[scr_CriteriaBuilder::Class_Initialize]") then exit sub

      ' do the rule
      set m_objMainForm = new scr_MainForm
      call m_objMainForm.SetWriter(me)

      set objCategoryList = new scr_CategoryList
      if m_objMainForm.CheckExtra(SCNT_EXTRA_ARRANGE) then
         if not objCategoryList.PrepareRequest(SCNT_CL_VAR_SHORT_DESCRIPTION, null, "[scr_ScreeningResults::Class_Initialize]") then exit sub
      else
         if not objCategoryList.PrepareRequest(SCNT_CL_VAR_SHORT_DESCRIPTION, Array(SCNT_USER_DEFINED_CATEGORY), "[scr_ScreeningResults::Class_Initialize]") then exit sub
      end if
      if not objRequestor.Add(objCategoryList, "[scr_ScreeningResults::Class_Initialize]") then exit sub

      set objScreen = new scr_Screen
      set objPortfolio = new scr_Portfolio
      set objFormat = new scr_Format
      set m_objResult = new scr_Result

      select case m_objMainForm.ProcessRule(objRequestor, objScreen, objPortfolio, objFormat, m_objResult)
      case SCNT_MFORM_RULE_FAIL
         exit sub
      case SCNT_MFORM_RULE_NONE
         select case m_objMainForm.GetRule()
         case "saveasformat"
            ' make the result
            if not CreateResult(objScreen, objPortfolio, objFormat) then exit sub
            
            ' prepare format's show list
            if not m_objResult.m_objHeaderList.MoveFirst() then exit sub
            do while m_objResult.m_objHeaderList.MoveNext()
               objFormat.AddShowVariable(m_objResult.m_objHeaderList.m_czVariable)
            loop
            
            ' save as ... format
            if not objFormat.IsDataExistsLt() then exit sub
            if not m_objMainForm.SaveAsFormat(objFormat) then exit sub

         case "saveportfolio", "saveasportfolio"
            set objResultForSave = new scr_ResultNoWrap
            if objResultForSave.Create("", 0, objScreen, objScreen.GetCurrentIndex(), objPortfolio, objPortfolio.GetType(), nothing, m_objResult.m_objRemovedList, m_objResult.m_objAddedList, nothing, 0, 0, "[scr_ScreeningResults::Class_Initialize]") then
               set objPortfolioForSave = scr_ConvertResultToPortfolio(objResultForSave)
               if scr_IsExists(objPortfolioForSave) then
                  if m_objMainForm.GetRule() = "saveportfolio" then
                     call ProcessSavePortfolio(objPortfolioForSave, objPortfolio)
                  else
                     call ProcessSaveAsPortfolio(objPortfolioForSave, objPortfolio)
                  end if
                  set objPortfolioForSave = nothing
               end if
            end if
         end select         
      end select

      call objRequestor.Send()

      if not CreateResult(objScreen, objPortfolio, objFormat) then exit sub

      ' create DHTML menu object
      set m_objMenu = new scr_Menu

      ' initialize main table
      set m_objMainTable = new scr_MainTable
      call m_objMainTable.Initialize(SCNT_MAINTABLE_RESULTS, "SwitchTab")

      ' initialize header table
      set m_objHeaderTable = new scr_HeaderTable
      call m_objHeaderTable.SetAll(m_objMenu, "Results: " & GetTotalMatch(), objDatasetList, objScreenList, objFormatList, objPortfolioList, objCategoryList, objScreen, objFormat, objPortfolio, m_objResult)
      call m_objHeaderTable.Initialize("")

      set m_objVariableTree = new scr_VariableTreeCtrl
      if m_objMainForm.CheckExtra(SCNT_EXTRA_ARRANGE) then
         call m_objVariableTree.Create(320, 262, false, "doInsertVariable", "VariableTree.asp")
      end if

      call m_objMainForm.SetObjects(objScreen, objPortfolio, objFormat, m_objResult)
   end sub

   ' -----------------------------------------------------------------------------
   ' objPortfolio [in]
   ' objCurrentPortfolio [in]
   private sub ProcessSavePortfolio(byref objPortfolio, byref objCurrentPortfolio)
      on error resume next
      dim objForRead
      dim czDesc : czDesc = null
      dim czShortDesc : czShortDesc = null
      
      if (not scr_IsExists(objPortfolio)) or (not scr_IsExists(objCurrentPortfolio)) then
         exit sub
      end if
      if (not objPortfolio.IsDataExistsLt()) or (objPortfolio.GetBuiltIn() = SCNT_BOOL_TRUE) then
         exit sub
      end if
      if (len(objCurrentPortfolio.GetCode()) <= 0) or (objCurrentPortfolio.GetBuiltIn() = SCNT_BOOL_TRUE) then
         exit sub
      end if
      
      set objForRead = new scr_Portfolio
      if objForRead.Create(objCurrentPortfolio.GetCode(), "[scr_ScreeningResults::ProcessSavePortfolio(1)]") then
         czDesc = objForRead.GetDescription()
         czShortDesc = objForRead.GetShortDescription()
      end if
      set objForRead = nothing
      if not objPortfolio.Save(objCurrentPortfolio.GetCode(), objCurrentPortfolio.GetName(), czShortDesc, czDesc, SCNT_SDR_PERSONAL or SCNT_P_FULL_PORTFOLIO or SCNT_SDR_UPDATE or SCNT_SDR_DROPMODIFY or SCNT_SDR_REFILL_CODENAMEBP, "[scr_ScreeningResults::ProcessSavePortfolio(2)]") then 
         exit sub
      end if
      set objCurrentPortfolio = objPortfolio
   end sub

   ' -----------------------------------------------------------------------------
   ' objPortfolio [in]
   ' objCurrentPortfolio [in]
   private sub ProcessSaveAsPortfolio(byref objPortfolio, byref objCurrentPortfolio)
      on error resume next
      dim objForRead
      dim czCode : czCode = ""
      dim czDesc : czDesc = null
      dim czShortDesc : czShortDesc = null

      if (not scr_IsExists(objPortfolio)) or (not scr_IsExists(objCurrentPortfolio)) then
         exit sub
      end if
      if not objPortfolio.IsDataExistsLt() then
         exit sub
      end if

      if len(objCurrentPortfolio.GetCode()) > 0 then
         set objForRead = new scr_Portfolio
         if objForRead.Create(objCurrentPortfolio.GetCode(), "[scr_ScreeningResults::ProcessSaveAsPortfolio(1)]") then
            czDesc = objForRead.GetDescription()
            czShortDesc = objForRead.GetShortDescription()
         end if
         set objForRead = nothing
      end if

      czCode = Trim(m_objMainForm.GetData())
      if len(czCode) <= 0 then czCode = scr_GenerateCode("P", scr_GetUserID())

      if not objPortfolio.Save(czCode, objCurrentPortfolio.GetName(), czShortDesc, czDesc, SCNT_SDR_PERSONAL or SCNT_P_FULL_PORTFOLIO or SCNT_SDR_SET or SCNT_SDR_DROPMODIFY or SCNT_SDR_REFILL_CODENAMEBP, "[scr_ScreeningResults::ProcessSaveAsPortfolio(2)]") then
         exit sub
      end if
      set objCurrentPortfolio = objPortfolio
   end sub

   ' -----------------------------------------------------------------------------
   ' objScreen [in]
   ' objPortfolio [in]
   ' objFormat [in]
   private function CreateResult(byref objScreen, byref objPortfolio, byref objFormat)
      on error resume next
'      dim objDbgReq
      dim iType : iType = SCNT_R_NONE

      CreateResult = false
      
      if m_bResultCreated then 
         CreateResult = true
         exit function
      end if
      m_bResultCreated = true

      if m_objMainForm.CheckExtra(SCNT_EXTRA_FORMAT) then
         iType = SCNT_R_SHORT_DESCRIPTION
      end if

      if not m_objResult.CreateLight("", iType, objScreen, objPortfolio, objPortfolio.GetType(), objFormat, "[scr_ScreeningResults::CreateResult(1)]") then
         if m_objResult.m_objTornadoError.IsExists() then
            if not m_objResult.CreateLight("", iType, nothing, objPortfolio, objPortfolio.GetType(), objFormat, "[scr_ScreeningResults::CreateResult(2)]") then exit function
         end if
      end if

'		set objDbgReq = new scr_DebugRequestor
'      call objDbgReq.Attach(m_objResult.GetRequest())
'      call objDbgReq.DebugRequest("::filerequest::E:\CalcReq.xml")
'      call objDbgReq.Attach(m_objResult.GetResponse())
'      call objDbgReq.DebugResponse("::fileresponse::E:\CalcResp.xml")

      CreateResult = true
   end function

   ' -----------------------------------------------------------------------------
   public sub WriteHead()
      on error resume next
   %>
      <link rel="stylesheet" href="css/nscreen.css" type="text/css">
      <script language="javascript" src="js/common.js" type="text/javascript"></script>
      <script language="javascript" src="js/mxmenu.js" type="text/javascript"></script>
      <script language="javascript" src="js/xmldom.js" type="text/javascript"></script>
      <script language="javascript" src="js/nscreendef.js" type="text/javascript"></script>
      <script language="javascript" src="js/nscreen.js" type="text/javascript"></script>
      <script language="javascript" src="js/results.js" type="text/javascript"></script>
   <%
   end sub

   ' -----------------------------------------------------------------------------
   public sub WriteBeginHTML()
      on error resume next
      call m_objMenu.WriteHTML()
      call m_objMainTable.WriteBeginHTML()
      call m_objHeaderTable.WriteBeginHTML()
      call m_objMainForm.WriteBeginHTML()
      call m_objVariableTree.WriteBeginHTML()
   %>
   <script>
   <%
      call m_objMenu.WriteBeginScript()
      call m_objMainTable.WriteBeginScript()
      call m_objHeaderTable.WriteBeginScript()
      call m_objMainForm.WriteBeginScript()
   %>
   </script>
   <%
   end sub

   ' -----------------------------------------------------------------------------
   public sub WriteEndHTML()
      on error resume next
      call m_objMainTable.WriteEndHTML()
      call m_objHeaderTable.WriteEndHTML()
      call m_objMainForm.WriteEndHTML()
      call m_objVariableTree.WriteEndHTML()
   %>
   <script>
   <%
      call m_objMenu.WriteEndScript()
      call m_objMainTable.WriteEndScript()
      call m_objHeaderTable.WriteEndScript()
      call m_objMainForm.WriteEndScript()
      call Response.Write(m_czEndScript)
   %>
   </script>
   <%
   end sub

   ' -----------------------------------------------------------------------------
   public sub WriteHTML()
      on error resume next
      dim bShowSortButtons

      m_iStartIndex = m_objResult.m_objRowList.GetStartPosition()
      m_iIndex = m_iStartIndex

      m_bFound = m_objResult.m_objRowList.IsCompanyFound()
      if m_objResult.m_objSearch.m_czValue <> "" then
         if not m_bFound then
            m_czEndScript = m_czEndScript & "SearchFailedDlg();"
         end if
      else
         m_bFound = false
      end if

      if m_objMainForm.CheckExtra(SCNT_EXTRA_FORMAT) then
         bShowSortButtons = false
      else
         bShowSortButtons = true
      end if
      call m_objMainTable.WriteHeader()
      call m_objHeaderTable.WriteHeader()
   %>
   <tr><td><img src="images/scr_dotFFFFFF.gif" width="1" height="3" border="0"></td></tr>
   <%
      call WriteLegend()
   %>
   <tr><td height="2" bgcolor="#BBBBBB"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td></tr>
   <%
      call WriteNavigation()
   %>
   <tr><td height="2" bgcolor="#BBBBBB"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td></tr>
   <tr>
      <td width="100%">
         <table border="0" cellspacing="0" cellpadding="0" width="100%">
   <%
      call WriteHeader(SCNT_WHT_TOP, bShowSortButtons)
      call WriteMainTable()
      if m_objMainForm.CheckExtra(SCNT_EXTRA_FORMAT) then
         call WriteAboveHeader()
         if SCNT_EXTRA_ARRANGE <> m_objMainForm.ExtraValue() then call WriteHeader(SCNT_WHT_BOTTOM, bShowSortButtons)
         if m_objMainForm.CheckExtra(SCNT_EXTRA_STATISTICS) then call WriteStatisticsEditor()
         if m_objMainForm.CheckExtra(SCNT_EXTRA_SORT) then call WriteSortEditor()
      else
         call WriteStatistics()
      end if
   %>
         </table>
      </td>
   </tr>
   <%
      if m_objMainForm.CheckExtra(SCNT_EXTRA_ARRANGE) then
         call WriteArrangeEditor()
      end if
      if m_objMainForm.CheckExtra(SCNT_EXTRA_FORMAT) then
         call WriteEditorFooter()
      end if
   %>
   <tr><td height="2" bgcolor="#BBBBBB"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td></tr>
   <%
      call WriteNavigation()
   %>
   <tr><td height="2" bgcolor="#BBBBBB"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td></tr>
   <%
      call WriteLegend()
      call m_objHeaderTable.WriteFooter()
      call m_objMainTable.WriteFooter()
      call m_objMainForm.WriteForm()
   end sub

   ' -----------------------------------------------------------------------------
   public sub WriteForm()
      on error resume next
   end sub

   ' -----------------------------------------------------------------------------
   private sub WriteLegend()
      on error resume next
   %>
   <tr><td class="scrresultsLegend">&nbsp;<img src="images/scr_greensquare.gif" border="0">&nbsp;In Screen only&nbsp;&nbsp;&nbsp;<img src="images/scr_orangesquare.gif" border="0">&nbsp;Added and In Screen&nbsp;&nbsp;&nbsp;<img src="images/scr_bluesquare.gif" border="0">&nbsp;Added and Not In Screen&nbsp;&nbsp;&nbsp;<img src="images/scr_pinksquare.gif" border="0">&nbsp;Statistics</td></tr>
   <%
   end sub

   ' -----------------------------------------------------------------------------
   private sub WriteNavigation()
      on error resume next
      dim iCount, iPageCount, iCurrPage, iStartPage, iEndPage
      dim iI

      iCount = m_objResult.m_objRowList.GetTotalMatch()
      iPageCount = Fix(iCount / SCNT_R_DEFAULT_COUNT_PER_PAGE) + 1
      iCurrPage = Fix(m_iStartIndex / SCNT_R_DEFAULT_COUNT_PER_PAGE) + 1
      if m_bFound then
         if iPageCount = 1 then
            iPageCount = 2
            iCurrPage = 2
         else
            if m_iStartIndex < 100 then
               iCurrPage = 0
            end if
         end if
      end if
   %>
   <tr>
      <td class="scrresultsNavTD">
         <table border="0" cellspacing="0" cellpadding="0">
         <tr>
            <td width="100%">
   <%
      if iPageCount = 2 then
         if iCurrPage = 1 then
   %>
               &nbsp;<span class="scrresultsNavLinks">&lt;&lt;&nbsp;Previous</span>
               &nbsp;&nbsp;&nbsp;<a href="javascript:SetStart(100);" class="scrresultsNavLinks">Next&nbsp;&gt;&gt;</a>
   <%
         elseif iCurrPage = 2 then
   %>
               &nbsp;<a href="javascript:SetStart(0);" class="scrresultsNavLinks">&lt;&lt;&nbsp;Previous</a>
               &nbsp;&nbsp;&nbsp;<span class="scrresultsNavLinks">Next&nbsp;&gt;&gt;</span>
   <%
         else
   %>
               &nbsp;<a href="javascript:SetStart(0);" class="scrresultsNavLinks">&lt;&lt;&nbsp;Previous</a>
               &nbsp;&nbsp;&nbsp;<a href="javascript:SetStart(100);" class="scrresultsNavLinks">Next&nbsp;&gt;&gt;</a>
   <%
         end if
      elseif 2 < iPageCount and iPageCount < SCNT_DEFAULT_PAGE_COUNT then
         if iCurrPage = 1 then
   %>
               &nbsp;<span class="scrresultsNavLinks">&lt;&lt;&nbsp;Previous</span>
               &nbsp;&nbsp;&nbsp;<span class="scrresultsNavLinks">1</span>
   <%
         else
   %>
               &nbsp;<a href="javascript:SetStart(<%=(iCurrPage - 2) * 100%>);" class="scrresultsNavLinks">&lt;&lt;&nbsp;Previous</a>
               &nbsp;&nbsp;&nbsp;<a href="javascript:SetStart(0);" class="scrresultsNavLinks">1</a>
   <%
         end if
         for iI = 2 to iPageCount - 1
            if iI = iCurrPage then
   %>
               &nbsp;<span class="scrresultsNavLinks"><%=iI%></span>
   <%
            else
   %>
               &nbsp;<a href="javascript:SetStart(<%=(iI - 1) * 100%>);" class="scrresultsNavLinks"><%=iI%></a>
   <%
            end if
         next
         if iCurrPage = iPageCount then
   %>
               &nbsp;<span class="scrresultsNavLinks"><%=iPageCount%></span>
               &nbsp;&nbsp;&nbsp;<span class="scrresultsNavLinks">Next&nbsp;&gt;&gt;</span>
   <%
         else
   %>
               &nbsp;<a href="javascript:SetStart(<%=(iPageCount - 1) * 100%>);" class="scrresultsNavLinks"><%=iPageCount%></a>
               &nbsp;&nbsp;&nbsp;<a href="javascript:SetStart(<%=iCurrPage * 100%>);" class="scrresultsNavLinks">Next&nbsp;&gt;&gt;</a>
   <%
         end if
      elseif iPageCount > SCNT_DEFAULT_PAGE_COUNT then
         iStartPage = iCurrPage - Fix(SCNT_DEFAULT_PAGE_COUNT / 2)
         iEndPage = iStartPage + SCNT_DEFAULT_PAGE_COUNT - 1
         if iStartPage < 1 then
            iStartPage = 1
            iEndPage = SCNT_DEFAULT_PAGE_COUNT
         elseif iEndPage > iPageCount then
            iStartPage = iPageCount - SCNT_DEFAULT_PAGE_COUNT + 1
            iEndPage = iPageCount
         end if
         if iCurrPage = 1 then
   %>
               &nbsp;<span class="scrresultsNavLinks">&lt;&lt;&lt;&nbsp;First</span>
               &nbsp;&nbsp;&nbsp;<span class="scrresultsNavLinks">&lt;&lt;&nbsp;Previous</span>
               &nbsp;&nbsp;&nbsp;<span class="scrresultsNavLinks"><%=iStartPage%></span>
   <%
         else
   %>
               &nbsp;<a href="javascript:SetStart(0);" class="scrresultsNavLinks">&lt;&lt;&lt;&nbsp;First</a>
               &nbsp;&nbsp;&nbsp;<a href="javascript:SetStart(<%=(iCurrPage - 2) * 100%>);" class="scrresultsNavLinks">&lt;&lt;&nbsp;Previous</a>
               &nbsp;&nbsp;&nbsp;<a href="javascript:SetStart(<%=(iStartPage - 1) * 100%>);" class="scrresultsNavLinks"><%=iStartPage%></a>
   <%
         end if
         for iI = iStartPage + 1 to iEndPage - 1
            if iI = iCurrPage then
   %>
               &nbsp;<span class="scrresultsNavLinks"><%=iI%></a>
   <%
            else
   %>
               &nbsp;<a href="javascript:SetStart(<%=(iI - 1) * 100%>);" class="scrresultsNavLinks"><%=iI%></a>
   <%
            end if
         next
         if iCurrPage = iPageCount then
   %>
               &nbsp;<span class="scrresultsNavLinks"><%=iPageCount%></span>
               &nbsp;&nbsp;&nbsp;<span class="scrresultsNavLinks">Next&nbsp;&gt;&gt;</span>
               &nbsp;&nbsp;&nbsp;<span class="scrresultsNavLinks">Last&nbsp;&gt;&gt;&gt;</span>
   <%
         else
   %>
               &nbsp;<a href="javascript:SetStart(<%=(iEndPage - 1) * 100%>);" class="scrresultsNavLinks"><%=iEndPage%></a>
               &nbsp;&nbsp;&nbsp;<a href="javascript:SetStart(<%=iCurrPage * 100%>);" class="scrresultsNavLinks">Next&nbsp;&gt;&gt;</a>
               &nbsp;&nbsp;&nbsp;<a href="javascript:SetStart(<%=(iPageCount - 1) * 100%>);" class="scrresultsNavLinks">Last&nbsp;&gt;&gt;&gt;</a>
   <%
         end if
      end if
   %>
            </td>
            <td align="right"><a href="javascript:FindDlg();"><img src="images/scr_findbtn.gif" alt="Find" border="0"></a></td>
         </tr>
         </table>
      </td>
   </tr>
   <%
   end sub

   ' -----------------------------------------------------------------------------
   private sub WriteSortButtons(czVariable, iSortType, iSortIndex)
      on error resume next
      if iSortType = SCNT_HL_NOT_SORTED then
   %>
   <br><a href="javascript:AddSort('<%=scr_JScriptStr4(czVariable)%>', <%=SCNT_HL_ASCENDED%>);"><img src="images/scr_sortupdark.gif" alt="Ascend" border="0"></a>&nbsp;<a href="javascript:AddSort('<%=czVariable%>', <%=SCNT_HL_DESCENDED%>);"><img src="images/scr_sortdowndark.gif" alt="Descend" border="0"></a>
   <%
      elseif iSortType = SCNT_HL_ASCENDED then
   %>
   <br><a href="javascript:RemoveSort('<%=scr_JScriptStr4(czVariable)%>');"><img src="images/scr_sortuplight.gif" alt="Remove sort" border="0"></a>&nbsp;<a href="javascript:ResetSort('<%=czVariable%>', <%=SCNT_HL_DESCENDED%>);"><img src="images/scr_sortdowndark.gif" alt="Descend" border="0"></a>&nbsp;<span class="scrresultsSortIndex"><%=iSortIndex%></span>
   <%
      elseif iSortType = SCNT_HL_DESCENDED then
   %>
   <br><a href="javascript:ResetSort('<%=scr_JScriptStr4(czVariable)%>', <%=SCNT_HL_ASCENDED%>);"><img src="images/scr_sortupdark.gif" alt="Ascend" border="0"></a>&nbsp;<a href="javascript:RemoveSort('<%=czVariable%>');"><img src="images/scr_sortdownlight.gif" alt="Remove sort" border="0"></a>&nbsp;<span class="scrresultsSortIndex"><%=iSortIndex%></span>
   <%
      end if
   end sub

   ' -----------------------------------------------------------------------------
   private sub WriteAboveHeader()
      on error resume next
      dim czHeader

      select case m_objMainForm.ExtraValue()
      case SCNT_EXTRA_STATISTICS
         czHeader = "Statistics"
      case SCNT_EXTRA_SORT
         czHeader = "Sort"
      case SCNT_EXTRA_ARRANGE
         czHeader = "Add / Remove / Arrange Columns"
      case else
         czHeader = "Format Editor"
      end select

      if m_objMainForm.ExtraValue() <> SCNT_EXTRA_ARRANGE then
   %>
         <tr><td width="1" bgcolor="#FFFFEB"><img src="images/scr_dotFFFFEB.gif" width="1" height="1" border="0"></td><td height="1" bgcolor="#BBBBBB" colspan="<%=(m_iTableColumnsEditor - 1)%>"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td></tr>
   <%
      else
   %>
         <tr><td height="1" bgcolor="#BBBBBB" colspan="<%=m_iTableColumnsEditor%>"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td></tr>
   <%
      end if
   %>
         <tr><td height="15" bgcolor="#FFFFEB" colspan="<%=m_iTableColumnsEditor%>"><a name="formateditor"><img src="images/scr_dotFFFFEB.gif" width="1" height="1" border="0"></a></td></tr>
         <tr><td colspan="<%=m_iTableColumnsEditor%>" class="dialogTD">&nbsp;<img src="images/scr_grarrowd.gif" vspace="2" width="9" height="5" border="0">&nbsp;<span class="dialogHeader"><%=czHeader%></span></td></tr>
         <tr><td height="3" bgcolor="#FFFFEB" colspan="<%=m_iTableColumnsEditor%>"><img src="images/scr_dotFFFFEB.gif" width="1" height="1" border="0"></td></tr>
   <%
      if m_objMainForm.ExtraValue() <> SCNT_EXTRA_ARRANGE then
   %>
         <tr><td height="1" bgcolor="#BBBBBB" colspan="<%=m_iTableColumnsEditor%>"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td></tr>
   <%
      end if
   end sub

   ' -----------------------------------------------------------------------------
   ' This function must be called before WriteMainTable and WriteStatistics
   ' iType [in]
   ' bShowSortButtons [in]
   private sub WriteHeader(iType, bShowSortButtons)
      on error resume next
      dim czVariable, czVariableArray
      dim iSortType, iSortIndex
      dim iI

      if not m_objResult.m_objHeaderList.MoveFirst() then exit sub
   %>
         <tr>
   <%
      if m_objMainForm.CheckExtra(SCNT_EXTRA_FORMAT) and m_objMainForm.ExtraValue() <> SCNT_EXTRA_ARRANGE then
         if iType = SCNT_WHT_TOP then
   %>
            <td class="dialogTD">&nbsp;</td><td width="1" bgcolor="#BBBBBB"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td><td class="scrresultsHeaderTD">&nbsp;</td>
   <%
         elseif iType = SCNT_WHT_BOTTOM then
            czVariableArray = "var scrg_arrVariable=["
            if m_objMainForm.CheckExtra(SCNT_EXTRA_STATISTICS) then
   %>
            <td colspan="2" class="scrresultsHeaderTD" align="right">&nbsp;<span class="scrresultsHeader">Check / Uncheck All</span></td><td class="scrresultsHeaderTD" align="center"><img src="images/scr_leftbottomarrow.gif" border="0"></td>
   <%
            else
   %>
            <td class="scrresultsHeaderTD">&nbsp;</td><td width="1" bgcolor="#BBBBBB"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td><td class="scrresultsHeaderTD">&nbsp;</td>
   <%
            end if
         end if
      else
   %>
            <td class="scrresultsHeaderTD">&nbsp;</td>
   <%
      end if

      iI = 0
      do while m_objResult.m_objHeaderList.MoveNext()
         if m_objResult.m_objHeaderList.m_iType = SCNT_HL_TICKER then m_iTickerColumn = iI
         if m_objResult.m_objHeaderList.m_iType = SCNT_HL_NAME then m_iNameColumn = iI
         czVariable = m_objResult.m_objHeaderList.m_czVariable
         iSortType = m_objResult.m_objHeaderList.m_iSortType
         iSortIndex = m_objResult.m_objHeaderList.m_iSortIndex
         if iType = SCNT_WHT_BOTTOM then
            czVariableArray = czVariableArray & "'" & scr_JScriptStr3(czVariable) & "',"
         end if
   %>
            <td class="scrresultsHeaderBLTD">&nbsp;</td><td class="scrresultsHeaderTD" valign="bottom" nowrap><span class="scrresultsHeader"><%=Join(m_objResult.m_objHeaderList.m_arrHeader, "<br>")%><%if bShowSortButtons then call WriteSortButtons(czVariable, iSortType, iSortIndex)%></span></td><td class="scrresultsHeaderTD">&nbsp;</td>
   <%
         iI = iI + 1
      loop
   %>
         </tr>
   <%
      if iType = SCNT_WHT_BOTTOM then
         if Right(czVariableArray, 1) = "," then
            czVariableArray = Left(czVariableArray, Len(czVariableArray) - 1) & "];"
            m_czEndScript = m_czEndScript & czVariableArray
         end if
      end if

      m_iColumns = iI
      m_iTableColumns = iI * 3 + 1
      if m_objMainForm.CheckExtra(SCNT_EXTRA_FORMAT) and m_objMainForm.ExtraValue() <> SCNT_EXTRA_ARRANGE then
         m_iTableColumnsEditor = m_iTableColumns + 2
      else
         m_iTableColumnsEditor = m_iTableColumns
      end if
   end sub

   ' -----------------------------------------------------------------------------
   ' This function must be called before WriteStatistics
   private sub WriteMainTable()
      on error resume next

      if m_iTableColumns = 0 then exit sub
      if not m_objResult.m_objRowList.MoveFirst() then exit sub

      if m_objResult.m_objRowList.MoveNext() then
         if m_bFound then
            call WriteMainTableRow(true)
         else
            call WriteMainTableRow(false)
         end if
      end if
      do while m_objResult.m_objRowList.MoveNext()
         call WriteMainTableRow(false)
      loop
   end sub

   ' -----------------------------------------------------------------------------
   private sub WriteMainTableRow(bBold)
      on error resume next
      dim czValue
      dim iI

      if m_objMainForm.CheckExtra(SCNT_EXTRA_FORMAT) and m_objMainForm.ExtraValue() <> SCNT_EXTRA_ARRANGE then
   %>
         <tr>
            <td class="dialogTD">&nbsp;</td><td width="1" bgcolor="#BBBBBB"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td>
   <%
      else
   %>
         <tr>
   <%
      end if
   %><td align="center" class="<%=TranslateType(m_objResult.m_objRowList.m_objColumnList.GetType())%>" nowrap>&nbsp;<%=GetDisplayableValue(CStr(m_iIndex) & ".", bBold)%>&nbsp;</td><%
      if not m_objResult.m_objRowList.m_objColumnList.MoveFirst() then
   %>
            <td class="<%=GetEvenOddClass(m_iIndex, false)%>" colspan="<%=m_iTableColumnsEditor%>">&nbsp;</td>
         </tr>
   <%
         exit sub
      end if
      iI = 0
      do while m_objResult.m_objRowList.m_objColumnList.MoveNext()
         if m_iTickerColumn = iI then
            czValue = m_objResult.m_objRowList.m_objColumnList.m_czValue
            if czValue = "" then czValue = "View Report"
   %><td colspan="3" class="<%=GetEvenOddClass(m_iIndex, true)%>">&nbsp;<a href="<%=GetReportLink(czValue, m_objResult.m_objRowList.m_objColumnList.GetRepoNo())%>" target="_blank" class="scrresultsTicker"><%=czValue%></a>&nbsp;</td><%
         elseif m_iNameColumn = iI then
   %><td colspan="3" class="<%=GetEvenOddClass(m_iIndex, true)%>" nowrap>&nbsp;<%=GetDisplayableValue(m_objResult.m_objRowList.m_objColumnList.m_czValue, bBold)%>&nbsp;</td><%
         else
   %><td colspan="3" class="<%=GetEvenOddClass(m_iIndex, true)%>" nowrap>&nbsp;<%=GetDisplayableValue(m_objResult.m_objRowList.m_objColumnList.m_czValue, bBold)%>&nbsp;</td><%
         end if
         iI = iI + 1
      loop
   %>
         </tr>
   <%
      m_iIndex = m_iIndex + 1
      if m_iIndex mod 10 = 0 then call Response.Flush()
   end sub

   ' -----------------------------------------------------------------------------
   ' czValue [in]
   ' bBold [in]
   private function GetDisplayableValue(czValue, bBold)
      on error resume next
      if bBold then
         GetDisplayableValue = "<b>" & czValue & "</b>"
      else
         GetDisplayableValue = czValue
      end if
   end function

   ' -----------------------------------------------------------------------------
   ' czTicker [in]
   ' czRepoNo [in]
   private function GetReportLink(czTicker, czRepoNo)
      on error resume next
      GetReportLink = "/GoTo.aspx?target=/stocks/quickinfo/stockoverview&ticker=" & czTicker & "&rn=" & czRepoNo
   end function

   ' -----------------------------------------------------------------------------
   private sub WriteStatistics()
      on error resume next
      dim czValue

      if m_iTableColumns = 0 then exit sub
      if not m_objResult.m_objStatRowList.MoveFirst() then exit sub

      do while m_objResult.m_objStatRowList.MoveNext()
   %>
         <tr>
            <td align="center" class="scrresultsStatisticsTD">&nbsp;</td>
   <%
         if not m_objResult.m_objStatRowList.m_objStatColumnList.MoveFirst() then
   %>
            <td class="<%=GetEvenOddClass(m_iIndex, true)%>" colspan="<%=m_iTableColumns%>">&nbsp;</td></tr>
   <%
            exit sub
         end if
         do while m_objResult.m_objStatRowList.m_objStatColumnList.MoveNext()
            czValue = m_objResult.m_objStatRowList.m_objStatColumnList.m_czValue
            if czValue <> "" then
   %><td colspan="3" class="<%=GetEvenOddClass(m_iIndex, true)%>" nowrap>&nbsp;<%=m_objResult.m_objStatRowList.m_objStatColumnList.m_czValue%>&nbsp;</td><%
            else
   %><td colspan="3" class="<%=GetEvenOddClass(m_iIndex, true)%>">&nbsp;</td><%
            end if
         loop
   %>
         </tr>
   <%
         m_iIndex = m_iIndex + 1
      loop
   end sub

   ' -----------------------------------------------------------------------------
   private sub WriteStatisticsEditor()
      on error resume next
      dim czShortName, czName, czVariable, czValue
      dim iI, iJ
      dim bIsRow, bShowEmptyRow

      if m_iTableColumns = 0 then exit sub

      m_czEndScript = m_czEndScript & "StatCorrectCheckAll();"

      if m_objResult.m_objStatRowList.MoveFirst() then
         bIsRow = m_objResult.m_objStatRowList.MoveNext()
      else
         bIsRow = false
      end if
   %>
         <form name="DlgStatistics">
   <%
      if m_objMainForm.ExtraValue() <> SCNT_EXTRA_STATISTICS then
   %>
         <tr><td height="1" bgcolor="#BBBBBB" colspan="<%=m_iTableColumnsEditor%>"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td></tr>
         <tr><td colspan="<%=m_iTableColumnsEditor%>" class="scrresultsNavTD">&nbsp;<span class="scrresultsHeader">Statistics</span></td></tr>
   <%
      end if
      for iI = SCNT_SVL_FIRST to SCNT_SVL_LAST
         call scr_GetStatisticsRowName(iI, czShortName, czName)
   %>
         <tr>
            <td class="scrresultsHeaderBTTD" nowrap>&nbsp;<span class="scrresultsHeader"><%=czName%></span>&nbsp;</td><td width="1" bgcolor="#BBBBBB"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td>
            <td align="center" class="<%=GetEvenOddClass(iI, false)%>"><input type="checkbox" onclick="StatCheckAll(this);" name="<%=czShortName%>" value="AllVariables"></td>
   <%
         bShowEmptyRow = true
         if bIsRow then
            if m_objResult.m_objStatRowList.m_objStatColumnList.GetType() = iI then
               if m_objResult.m_objStatRowList.m_objStatColumnList.MoveFirst() then
                  iJ = 0
                  do while m_objResult.m_objStatRowList.m_objStatColumnList.MoveNext()
                     bShowEmptyRow = false
                     czVariable = m_objResult.m_objStatRowList.m_objStatColumnList.m_czVariable
                     czValue = m_objResult.m_objStatRowList.m_objStatColumnList.m_czValue
   %>
            <td class="<%=GetEvenOddClass(iI, true)%>">&nbsp;</td><td align="center" class="<%=GetEvenOddClass(iI, false)%>"><%call WriteStatisticsCheck(m_objResult.m_objStatRowList.m_objStatColumnList, czShortName, czVariable, czValue)%></td><td class="<%=GetEvenOddClass(iI, false)%>">&nbsp;</td>
   <%
                     iJ = iJ + 1
                  loop
                  call m_objResult.m_objStatRowList.MoveNext()
               end if
            end if
         end if

         if bShowEmptyRow then
            if m_objResult.m_objHeaderList.MoveFirst() then
               iJ = 0
               do while m_objResult.m_objHeaderList.MoveNext()
                  czVariable = m_objResult.m_objHeaderList.m_czVariable
   %>
            <td class="<%=GetEvenOddClass(iI, true)%>">&nbsp;</td><td align="center" class="<%=GetEvenOddClass(iI, false)%>"><%call WriteStatisticsCheck(m_objResult.m_objHeaderList, czShortName, czVariable, "")%></td><td class="<%=GetEvenOddClass(iI, false)%>">&nbsp;</td>
   <%
                  iJ = iJ + 1
               loop
            end if
         end if
   %>
         </tr>
   <%
      next
   %>
         <tr><td height="1" bgcolor="#BBBBBB" colspan="<%=m_iTableColumnsEditor%>"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td></tr>
         </form>
   <%
   end sub

   ' -----------------------------------------------------------------------------
   private sub WriteStatisticsCheck(objChecker, czShortName, czVariable, czValue)
      on error resume next
      dim czChecked

      if objChecker.m_bHasStatistics then
         if czValue <> "" then
            czChecked = " checked"
         else
            czChecked = ""
         end if
   %><input type="checkbox" onclick="StatCorrectCheckAll();" name="<%=scr_ConvertToAttrEscapes(czShortName)%>" value="<%=scr_ConvertToAttrEscapes(czVariable)%>"<%=czChecked%>><%
      else
   %>&nbsp;<%
      end if
   end sub

   ' -----------------------------------------------------------------------------
   private sub WriteSortEditor()
      on error resume next
      dim czOrderIndexArray, czOrderTypeArray
      dim iI, iMaxSortIndex

      if m_iTableColumns = 0 then exit sub
      if not m_objResult.m_objHeaderList.MoveFirst() then exit sub

      m_czEndScript = m_czEndScript & "SortPlaceOrderLayers();SortCorrectOrder();"

   %>
         <form name="DlgSort">
   <%
      if m_objMainForm.ExtraValue() <> SCNT_EXTRA_SORT then
   %>
         <tr><td colspan="<%=m_iTableColumnsEditor%>" class="scrresultsNavTD">&nbsp;<span class="scrresultsHeader">Sort</span></td></tr>
   <%
      end if
   %>
         <tr>
            <td class="scrresultsHeaderBTTD">&nbsp;<span class="scrresultsHeader">Ascending</span>&nbsp;</td><td width="1" bgcolor="#BBBBBB"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td>
            <td class="scrresultsHeaderBTTD" rowspan="5" align="center"><a href="javascript:SortClearAll();"><img src="images/scr_clearallbtn.gif" alt="Clear All" border="0"></a></td>
   <%
      iI = 0
      do while m_objResult.m_objHeaderList.MoveNext()
   %>
            <td class="scrresultsOddRowBLTD">&nbsp;</td><td align="center" class="scrresultsOddRowTD"><%call WriteSortCheck(m_objResult.m_objHeaderList, iI, SCNT_HL_ASCENDED)%></td><td class="scrresultsOddRowTD">&nbsp;</td>
   <%
         iI = iI + 1
      loop
   %>

         <tr>
            <td class="scrresultsHeaderBTTD">&nbsp;<span class="scrresultsHeader">Descending</span>&nbsp;</td><td width="1" bgcolor="#BBBBBB"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td>
   <%
      iI = 0
      call m_objResult.m_objHeaderList.MoveFirst()
      do while m_objResult.m_objHeaderList.MoveNext()
   %>
            <td class="scrresultsEvenRowBLTD">&nbsp;</td><td align="center" class="scrresultsEvenRowTD"><%call WriteSortCheck(m_objResult.m_objHeaderList, iI, SCNT_HL_DESCENDED)%></td><td class="scrresultsEvenRowTD">&nbsp;</td>
   <%
         iI = iI + 1
      loop
   %>

         <tr>
            <td class="scrresultsHeaderBTTD">&nbsp;<span class="scrresultsHeader">Order</span>&nbsp;</td><td width="1" bgcolor="#BBBBBB"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td>
   <%
      iI = 1
      iMaxSortIndex = 0
      czOrderIndexArray = "var scrg_arrOrderIndex=["
      czOrderTypeArray = "var scrg_arrOrderType=["
      call m_objResult.m_objHeaderList.MoveFirst()
      do while m_objResult.m_objHeaderList.MoveNext()
         if iMaxSortIndex < m_objResult.m_objHeaderList.m_iSortIndex then iMaxSortIndex = m_objResult.m_objHeaderList.m_iSortIndex
         czOrderIndexArray = czOrderIndexArray & m_objResult.m_objHeaderList.m_iSortIndex & ","
         czOrderTypeArray = czOrderTypeArray & m_objResult.m_objHeaderList.m_iSortType & ","
   %>
            <td class="scrresultsOddRowBLTD">&nbsp;</td><%call WriteOrderItem(iI, m_objResult.m_objHeaderList.m_iSortIndex)%><td class="scrresultsOddRowTD">&nbsp;</td>
   <%
         iI = iI + 1
      loop
      if Right(czOrderIndexArray, 1) = "," then
         czOrderIndexArray = Left(czOrderIndexArray, Len(czOrderIndexArray) - 1) & "];var scrg_iMaxSortIndex=" & iMaxSortIndex & ";"
         m_czEndScript = czOrderIndexArray & m_czEndScript
      end if
      if Right(czOrderTypeArray, 1) = "," then
         czOrderTypeArray = Left(czOrderTypeArray, Len(czOrderTypeArray) - 1) & "];"
         m_czEndScript = czOrderTypeArray & m_czEndScript
      end if
   %>
         </tr>
         <tr><td height="1" bgcolor="#BBBBBB" colspan="<%=m_iTableColumnsEditor%>"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td></tr>
         </form>
   <%
   end sub

   ' -----------------------------------------------------------------------------
   private sub WriteSortCheck(objHeader, iIndex, iSortType)
      on error resume next
      dim czChecked, czIndex

      if objHeader.m_iSortType = iSortType then
         czChecked = " checked"
         czIndex = CStr(objHeader.m_iSortIndex)
      else
         czChecked = ""
         czIndex = ""
      end if

   %><input type="radio" onclick="SortCheckChanged(this);" name="<%=scr_ConvertToAttrEscapes(objHeader.m_czVariable)%>" value="<%=iIndex%>:<%=iSortType%>"<%=czChecked%>><%
   end sub

   ' -----------------------------------------------------------------------------
   ' iIndex [in]
   ' iSortIndex [in]
   public sub WriteOrderItem(iIndex, iSortIndex)
      on error resume next
      dim czText
      if scrg_brType = SCNT_NN4 then
   %><td class="scrresultsOddRowTD"><ilayer id="BindOrder<%=iIndex%>" width="100%" visibility="hide">&nbsp;</ilayer><layer id="Order<%=iIndex%>" class="scrresultsHeader" visibility="hide"><%=iIndex%></layer></td><%
      else
         if iSortIndex <> 0 then
            czText = CStr(iSortIndex)
         else
            czText = "&nbsp;"
         end if
   %><td id="Order<%=iIndex%>" class="scrresultsOddRowTD scrresultsHeader" align="center"><%=czText%></td><%
      end if
   end sub

   ' -----------------------------------------------------------------------------
   private sub WriteArrangeEditor()
      on error resume next

      if m_objMainForm.ExtraValue() <> SCNT_EXTRA_ARRANGE then
   %>
   <tr><td class="scrresultsNavTD">&nbsp;<span class="scrresultsHeader">Add / Remove / Arrange Columns</span></td></tr>
   <tr><td height="1" bgcolor="#BBBBBB"><img src="images/scr_dotBBBBBB.gif" width="1" height="1" border="0"></td></tr>
   <tr><td height="5" bgcolor="#FFFFEB"><img src="images/scr_dotFFFFEB.gif" width="1" height="1" border="0"></td></tr>
   <%
      end if
   %>
   <form name="DlgArrange">
   <tr>
      <td class="dialogTD">
         <table border="0" cellspacing="0" cellpadding="0">
         <tr>
            <td>&nbsp;&nbsp;&nbsp;</td>
            <td valign="top">
               <span class="dialogHeader">Current Variable List:</span><br>
               <span class="dialogText">
                  <select multiple name="ShowList" <%if scrg_brType = SCNT_IE then%>size="16"<%else%>size="22"<%end if%> class="dialogCurrVarList" onchange="onShowListSelectionChanged();">
   <%
      if m_objResult.m_objHeaderList.MoveFirst() then
         do while m_objResult.m_objHeaderList.MoveNext()
   %>
                  <option value="<%=scr_ConvertToAttrEscapes(m_objResult.m_objHeaderList.m_czVariable)%>"><%=GetVariableDescription(m_objResult.m_objHeaderList.m_czShortDescription)%> [<%=GetVariableDescription(m_objResult.m_objHeaderList.m_czVariable)%>]
   <%
         loop
      end if
      if scrg_brType = SCNT_NN4 then
   %>
                  <option value="">-----------------------------------------------------------
   <%
      end if
   %>
                  </select><br><br>
                  <center>
                     <a href="javascript:doArrangeMoveUp();"><img id="MoveUpImage" name="MoveUpImage" src="images/scr_upbtn_grey.gif" border="0" alt="Up"></a>&nbsp;&nbsp;&nbsp;
                     <a href="javascript:doArrangeMoveDown();"><img id="MoveDownImage" name="MoveDownImage" src="images/scr_downbtn_grey.gif" border="0" alt="Down"></a>
                  </center>
               </span>
            </td>
            <td>&nbsp;&nbsp;&nbsp;</td>
            <td>
               <a href="javascript:doRemoveVariable();"><img name="RemoveImage" id="RemoveImage" src="images/scr_removebtn_grey.gif" alt="Remove" border="0"></a><br>
            </td>
            <td>&nbsp;&nbsp;&nbsp;</td>
            <td valign="top">
               <span class="dialogHeader">All Variables:</span><br>
   <%
      call m_objVariableTree.WriteHTML()
   %>
            </td>
         </tr>
         </table>
      </td>
   </tr>
   </form>
   <%
   end sub

   ' -----------------------------------------------------------------------------
   private function GetVariableDescription(czDescription)
      on error resume next
      if scrg_brType = SCNT_NN4 then
         GetVariableDescription = scr_Ellipsis(czDescription, 40)
      else
         GetVariableDescription = czDescription
      end if
   end function

   ' -----------------------------------------------------------------------------
   private function WriteEditorFooter()
      on error resume next
   %>
   <tr><td class="dialogTD">&nbsp;</td></tr>
   <tr><td class="dialogTD">&nbsp;&nbsp;&nbsp;<a href="javascript:doOk();"><img src="images/scr_okbtn.gif" alt="Ok" border="0"></a>&nbsp;&nbsp;&nbsp;<a href="javascript:doCancel();"><img src="images/scr_cancelbtn.gif" alt="Cancel" border="0"></a></td></tr>
   <tr><td class="dialogTD">&nbsp;</td></tr>
   <%
   end function

   ' -----------------------------------------------------------------------------
   private function TranslateType(iType)
      on error resume next
      select case iType
      case SCNT_R_COMPANY_CRITERIA
         TranslateType = "scrresultsInScreenOnlyTD"
      case SCNT_R_COMPANY_INCLUDE
         TranslateType = "scrresultsNotInScreenTD"
      case (SCNT_R_COMPANY_CRITERIA or SCNT_R_COMPANY_INCLUDE)
         TranslateType = "scrresultsInScreenTD"
      case else
         TranslateType = "scrresultsInScreenOnlyTD"
      end select
   end function

   ' -----------------------------------------------------------------------------
   private function GetEvenOddClass(iIndex, bBorderLeft)
      on error resume next
      if iIndex mod 2 = 0 then
         if bBorderLeft then
            GetEvenOddClass = "scrresultsOddRowBLTD"
         else
            GetEvenOddClass = "scrresultsOddRowTD"
         end if
      else
         if bBorderLeft then
            GetEvenOddClass = "scrresultsEvenRowBLTD"
         else
            GetEvenOddClass = "scrresultsEvenRowTD"
         end if
      end if
   end function

   ' -----------------------------------------------------------------------------
   private function GetTotalMatch()
      on error resume next
      dim iCount

      iCount = m_objResult.m_objRowList.GetTotalMatch()
      if iCount = 1 then
         GetTotalMatch = CStr(iCount) & " Total Match"
      else
         GetTotalMatch = CStr(iCount) & " Total Matches"
      end if
   end function

   private m_bFound
   private m_czEndScript

   private m_iColumns
   private m_iTableColumns
   private m_iTableColumnsEditor
   private m_iTickerColumn
   private m_iNameColumn

   private m_iStartIndex
   private m_iIndex

   private m_objVariableTree
   private m_objMenu
   private m_objMainTable
   private m_objHeaderTable
   private m_objResult
   private m_objMainForm

   private m_bResultCreated
end class

' -----------------------------------------------------------------------------
' main code
' -----------------------------------------------------------------------------

if not SCNT_INCLUDEMODE then
   dim objScreeningResults : set objScreeningResults = new scr_ScreeningResults
   call scr_Header(objScreeningResults)
   call objScreeningResults.WriteHTML()
   call scr_Footer(objScreeningResults)
end if

%>
